local Addon = _G[...]
local BattlePetSlot = Addon.ActionSlots:CreateKind("battlepet")

local SUMMON_RANDOM_PET_ID = "BattlePet-0-FFFFFFFFFFFFFF"
local SUMMON_RANDOM_PET_SPELL_ID = 243819

function BattlePetSlot:GetActionCharges()
    return 0, 0, 0, 0, 0
end

function BattlePetSlot:GetActionCooldown()
    return C_PetJournal.GetSummonBattlePetCooldown()
end

function BattlePetSlot:GetActionCount()
    return 0
end

function BattlePetSlot:GetActionID()
    return
end

function BattlePetSlot:GetActionInfo()
    return "summonpet", self:GetAttribute("battlepet")
end

function BattlePetSlot:GetActionLossOfControlCooldown()
    return 0, 0
end

function BattlePetSlot:GetActionText()
    return ""
end

function BattlePetSlot:GetActionTexture()
    local battlePetID = self:GetAttribute("battlepet")

    if battlePetID == SUMMON_RANDOM_PET_ID then
        return (select(3, _G.GetSpellInfo(SUMMON_RANDOM_PET_SPELL_ID)))
    end

    return (select(9, _G.C_PetJournal.GetPetInfoByPetID(battlePetID)))
end

function BattlePetSlot:GetItemID()
    return
end

function BattlePetSlot:GetSpellID()
    if self:GetAttribute("battlepet") == SUMMON_RANDOM_PET_ID then
        return SUMMON_RANDOM_PET_SPELL_ID
    end
end

function BattlePetSlot:HasAction()
    return true
end

function BattlePetSlot:IsActionInRange()
end

function BattlePetSlot:IsAttackAction()
    return false
end

function BattlePetSlot:IsAutoCastAction()
    return false
end

function BattlePetSlot:IsAutoRepeatAction()
    return false
end

function BattlePetSlot:IsConsumableAction()
    return false
end

function BattlePetSlot:IsCurrentAction()
    return C_PetJournal.GetSummonedPetGUID() == self:GetAttribute("battlepet")
end

function BattlePetSlot:IsEquippedAction()
    return false
end

function BattlePetSlot:IsItemAction()
    return false
end

function BattlePetSlot:IsStackableAction()
    return false
end

function BattlePetSlot:IsUsableAction()
    return true
end

function BattlePetSlot:SetTooltip(tooltip)
    local petID = self:GetAttribute("battlepet")

    if petID == SUMMON_RANDOM_PET_ID then
        return tooltip:SetSpellByID(SUMMON_RANDOM_PET_SPELL_ID)
    end

    if petID then
        -- SetCompanionPet appends and doesn't clear, so do this to fix
        tooltip:ClearLines()
        return tooltip:SetCompanionPet(petID)
    end
end

function BattlePetSlot.Pickup(battlePetID)
    if battlePetID == SUMMON_RANDOM_PET_ID then
        return _G.C_PetJournal.PickupSummonRandomPet()
    end
    return _G.C_PetJournal.PickupPet(battlePetID)
end

Addon.BattlePetSlot = BattlePetSlot