local Addon = _G[...]
local EquipmentSetSlot = Addon.ActionSlots:CreateKind("equipmentset")

function EquipmentSetSlot:GetActionCharges()
    return 0, 0, 0, 0, 0
end

function EquipmentSetSlot:GetActionCooldown()
    return 0, 0, 0, 0
end

function EquipmentSetSlot:GetActionCount()
    return 0
end

function EquipmentSetSlot:GetActionID()
    return 0
end

function EquipmentSetSlot:GetActionInfo()
    return "equipmentset", self:GetAttribute("equipmentset")
end

function EquipmentSetSlot:GetActionLossOfControlCooldown()
    return 0, 0
end

function EquipmentSetSlot:GetActionText()
    return self:GetSetInfo() or ""
end

function EquipmentSetSlot:GetActionTexture()
    local _, iconFileID = self:GetSetInfo()
    return iconFileID
end

function EquipmentSetSlot:GetItemID()
    return 0
end

function EquipmentSetSlot:GetSpellID()
    return 0
end

function EquipmentSetSlot:HasAction()
    return true
end

function EquipmentSetSlot:IsActionInRange()
end

function EquipmentSetSlot:IsAttackAction()
    return false
end

function EquipmentSetSlot:IsAutoCastAction()
    return false
end

function EquipmentSetSlot:IsAutoRepeatAction()
    return false
end

function EquipmentSetSlot:IsConsumableAction()
    return false
end

function EquipmentSetSlot:IsCurrentAction()
    return false
end

function EquipmentSetSlot:IsEquippedAction()
    local isEquipped = select(4, self:GetSetInfo())
    return isEquipped
end

function EquipmentSetSlot:IsItemAction()
    return false
end

function EquipmentSetSlot:IsStackableAction()
    return false
end

function EquipmentSetSlot:IsUsableAction()
    return not InCombatLockdown()
end

function EquipmentSetSlot:GetSetID()
    local setName = self:GetAttribute("equipmentset")
    if setName then
        return _G.C_EquipmentSet.GetEquipmentSetID(setName)
    end
end

function EquipmentSetSlot:GetSetInfo()
    local id = self:GetSetID()
    if id then
        return _G.C_EquipmentSet.GetEquipmentSetInfo(self:GetSetID())
    end
end

function EquipmentSetSlot:SetTooltip(tooltip)
    local setName = self:GetAttribute("equipmentset")
    if setName then
        return GameTooltip_SetTitle(tooltip, setName, HIGHLIGHT_FONT_COLOR)
    end
end

function EquipmentSetSlot.Pickup(setIDorName)
    if setIDorName then
        local setID = _G.C_EquipmentSet.GetEquipmentSetID(setIDorName)

        if setID then
            return _G.C_EquipmentSet.PickupEquipmentSet(setID)
        end
    end
end

Addon.EquipmentSetSlot = EquipmentSetSlot