local AddonName = ...
local Addon = _G[AddonName]
local ExitVehicleSlot = Addon.ActionSlots:CreateKind("exitvehicle")
local EXIT_VEHICLE_ICON = ([[Interface\Addons\%s\images\vehicle_exit.tga]]):format(AddonName)

-- charges, maxCharges, chargeStart, chargeDuration
function ExitVehicleSlot:GetActionCharges()
    return 0, 0, 0, 0
end

function ExitVehicleSlot:GetActionCooldown()
    return 0, 0, 0, 0
end

function ExitVehicleSlot:GetActionCount()
    return 0
end

function ExitVehicleSlot:GetActionID()
    return 0
end

function ExitVehicleSlot:GetActionInfo()
    return
end

function ExitVehicleSlot:GetActionLossOfControlCooldown()
    return 0, 0
end

function ExitVehicleSlot:GetActionText()
    return ""
end

function ExitVehicleSlot:GetActionTexture()
    return EXIT_VEHICLE_ICON
end

function ExitVehicleSlot:GetItemID()
    return 0
end

function ExitVehicleSlot:GetSpellID()
    return 0
end

function ExitVehicleSlot:HasAction()
    return true
end

function ExitVehicleSlot:IsActionInRange()
end

function ExitVehicleSlot:IsAttackAction()
    return false
end

function ExitVehicleSlot:IsAutoCastAction()
    return false
end

function ExitVehicleSlot:IsAutoRepeatAction()
    return false
end

function ExitVehicleSlot:IsConsumableAction()
    return false
end

function ExitVehicleSlot:IsCurrentAction()
    return false
end

function ExitVehicleSlot:IsEquippedAction()
    return false
end

function ExitVehicleSlot:IsItemAction()
    return false
end

function ExitVehicleSlot:IsStackableAction()
    return false
end

function ExitVehicleSlot:IsUsableAction()
    return CanExitVehicle()
end

function ExitVehicleSlot.Pickup()
    return Addon.SecureEnv:PickupCustom(
        "exitvehicle",
        true,
        EXIT_VEHICLE_ICON
    )
end

function ExitVehicleSlot.GetIcon()
    return EXIT_VEHICLE_ICON
end

function ExitVehicleSlot:SetTooltip(tooltip)
    GameTooltip_SetTitle(tooltip, BINDING_NAME_VEHICLEEXIT, HIGHLIGHT_FONT_COLOR)
end

Addon.ExitVehicleSlot = ExitVehicleSlot