local Addon = _G[...]
local PetCommandSlot = Addon.ActionSlots:CreateKind("petcommand")
local PetActions = Addon.PetActions

-- charges, maxCharges, chargeStart, chargeDuration
function PetCommandSlot:GetActionCharges()
    return 0, 0, 0, 0
end

function PetCommandSlot:GetActionCooldown()
    return 0, 0, 0, 0
end

function PetCommandSlot:GetActionCount()
    return 0
end

function PetCommandSlot:GetActionID()
    return 0
end

function PetCommandSlot:GetActionInfo()
    return "spell", 0, "pet"
end

function PetCommandSlot:GetActionLossOfControlCooldown()
    return 0, 0
end

function PetCommandSlot:GetActionText()
    return ""
end

function PetCommandSlot:GetActionTexture()
    local actionID = self:GetAttribute("petActionID")

    if actionID then
        return (select(3, PetActions:GetPetActionIDInfo(actionID)))
    end
end

function PetCommandSlot:GetItemID()
    return 0
end

function PetCommandSlot:GetSpellID()
    return 0
end

function PetCommandSlot:HasAction()
    return true
end

function PetCommandSlot:IsActionInRange()
end

function PetCommandSlot:IsAttackAction()
    local actionID = self:GetAttribute("petActionID")

    if actionID then
        return PetActions:IsPetAttackAction(actionID)
    end
end

function PetCommandSlot:IsAutoCastAction()
    return false
end

function PetCommandSlot:IsAutoRepeatAction()
    return false
end

function PetCommandSlot:IsConsumableAction()
    return false
end

function PetCommandSlot:IsCurrentAction()
    if self:IsAttackAction() then
        return IsPetAttackActive()
    end
end

function PetCommandSlot:IsEquippedAction()
    return false
end

function PetCommandSlot:IsItemAction()
    return false
end

function PetCommandSlot:IsStackableAction()
    return false
end

function PetCommandSlot:IsUsableAction()
    return IsPetActive()
end

function PetCommandSlot:SetTooltip(tooltip)
    local name = PetActions:GetPetActionIDInfo(self:GetAttribute("petActionID"))

    if name then
        GameTooltip_SetTitle(tooltip, name, HIGHLIGHT_FONT_COLOR)
        return true
    end
end

Addon.PetCommandSlot = PetCommandSlot